(*
 *  File:     $RCSfile: FileMapStreams.pas,v $
 *  Revision: $Revision: 1.1.1.1 $
 *  Version : $Id: FileMapStreams.pas,v 1.1.1.1 2003/08/17 12:57:22 tothpaul Exp $
 *  Author:   $Author: tothpaul $
 *  Homepage: http://delphimpeg.sourceforge.net/
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *)
unit FileMapStreams;

interface

uses
 Windows,Classes,SysUtils;

type
 TFileMapStream=class(TCustomMemoryStream)
 private
  fFile:THandle;
  fMap :THandle;
 public
  constructor Create(const FileName: string);
  destructor destroy; override;
 end;

implementation

constructor TFileMapStream.Create(const FileName:string);
var
 Size:cardinal;
 Base:pointer;
begin
 fFile:=CreateFile(PChar(FileName),GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
 if fFile=0 then raise Exception.Create('Unable to open '+FileName);
 Size:=GetFileSize(fFile,nil);
 if Size=0 then raise Exception.Create('Empty file '+FileName);
 fMap :=CreateFileMapping(fFile,nil,PAGE_READONLY,0,0,nil);
 if fMap=0 then raise Exception.Create('Can''t map file '+FileName);
 Base:=MapViewOfFile(fMap,FILE_MAP_READ,0,0,0);
 if Base=nil then raise Exception.Create('Can''t view file '+FileName);
 SetPointer(Base,Size);
end;

destructor TFileMapStream.Destroy;
begin
 UnMapViewOfFile(Memory);
 CloseHandle(fMap);
 CloseHandle(fFile);
 inherited;
end;

end.
