unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Menus,ShellAPI, MPEGPlayer,WaveOut;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Bevel1: TBevel;
    Label2: TLabel;
    Label3: TLabel;
    PopupMenu1: TPopupMenu;
    Label4: TLabel;
    procedure Label2Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure Label1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Label4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    MouseX,MouseY:integer;
    Player:TMPEGPlayer;
    WaveOut:TWaveOut;
    Fmt:string;
    procedure WMDropFiles(Var Msg:TMessage); message WM_DROPFILES;
    procedure PlayFile(Sender:TObject);
    procedure OnIdle(Sender:TObject; var Done:boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 Player:=TMPEGPlayer.Create;
 WaveOut:=TWaveOut.Create;
 Application.OnIdle:=OnIdle;
 DragAcceptFiles(Handle,True);
end;

procedure TForm1.OnIdle(Sender:TObject; var Done:boolean);
begin
 Done:=False;
 Sleep(50);
 if (Label4.Tag=1)and(Player.Position<Player.Length) then begin
  Label4.Caption:=Format(Fmt, [Player.Position div 60, Player.Position mod 60])
 end else begin
  if PopupMenu1.Items.Count=0 then begin
   Label4.Tag:=0;
   Label4.Caption:='--:--';
   Hint:='Drop a file on me !';
  end else begin
   PlayFile(PopupMenu1.Items[0]);
  end;
 end;
end;

procedure TForm1.WMDropFiles(Var Msg:TMessage);
Const
 MaxLen=512;
var
 count:integer;
 s:string;
 i:integer;
 l:integer;
 m:TMenuItem;
begin
 count:=DragQueryFile(Msg.wParam,uint(-1),nil,0);
 for i:=0 to count-1 do begin
  SetLength(s,MaxLen);
  l:=DragQueryFile(Msg.wParam,i,pchar(s),length(s));
  Setlength(s,l);
  if UpperCase(ExtractFileExt(s))='.MP3' then begin
   m:=NewItem(ExtractFileName(s),0,False,True,PlayFile,0,'');
   m.Hint:=s;
   PopupMenu1.Items.Add(m);
  end;
 end;
 DragFinish(Msg.wParam);
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.Label3Click(Sender: TObject);
begin
 WindowState:=wsMinimized;
end;

procedure TForm1.Label1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Label1.Tag:=1;
 MouseX:=x;
 MouseY:=y;
 SetCaptureControl(Label1);
end;

procedure TForm1.Label1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Label1.Tag:=0;
 SetCaptureControl(nil);
end;

procedure TForm1.Label1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if Label1.Tag=1 then begin
  Left:=Left+X-MouseX;
  Top:=Top+Y-MouseY;
 end;
end;

procedure TForm1.PlayFile(Sender:TObject);
var
 m:TMenuItem;
begin
 m:=Sender as TMenuItem;
 Player.LoadFromFile(m.Hint);
 Fmt:='%d:%.2d'+Format(' of %d:%.2d (%d KBps)', [Player.Length div 60, Player.Length mod 60, Player.Bitrate div 1000]);
 Player.Play(WaveOut);
 Hint:=m.Caption;
 m.Free;
 Label4.Tag:=1;
end;

procedure TForm1.Label4MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 PopupMenu1.Popup(Left+Label4.Left+x,Top+Label4.Top+y);
end;

end.
