unit xmain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Menus,ShellAPI, MPEGPlayer,DirectSoundOut;

type
  TForm1 = class(TForm)
    Bevel1: TBevel;
    PlayList: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    procedure WMDropFiles(Var Msg:TMessage); message WM_DROPFILES;
    procedure OnIdle(Sender:TObject; var Done:boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
 TDSPlayer=class(TMPEGPlayer)
 private
  WaveOut:TDirectSoundOut;
  Fmt:string;
 public
  constructor Create(AFileName:string);
  destructor Destroy; override;
  function Idle:string;
 end;

Constructor TDSPlayer.Create(AFileName:string);
begin
 inherited Create;
 WaveOut:=TDirectSoundOut.Create;
 LoadFromFile(AFileName);
 Fmt:='%d:%.2d'+Format(' of %d:%.2d (%d KBps)', [Length div 60, Length mod 60, Bitrate div 1000]);
 Play(WaveOut);
end;

function TDSPlayer.Idle:string;
begin
 if Position<Length then
  Result:=Format(Fmt, [Position div 60, Position mod 60])
 else begin
  Result:='';
 end;
end;

destructor TDSPlayer.Destroy;
begin
 Stop;
 WaveOut.Free;
 inherited;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Application.OnIdle:=OnIdle;
 DragAcceptFiles(Handle,True);
end;

procedure TForm1.OnIdle(Sender:TObject; var Done:boolean);
var
 i:integer;
 p:TDSPlayer;
 s:string;
begin
 Done:=False;
 Sleep(50);
 PlayList.Items.BeginUpdate;
 try
  for i:=PlayList.Count-1 downto 0 do begin
   p:=PlayList.Items.Objects[i] as TDSPlayer;
   s:=p.Idle;
   if s='' then begin
    p.Free;
    PlayList.Items.Delete(i);
   end else begin
    if PlayList.Items[i]<>s then PlayList.Items[i]:=s;
   end;
  end;
 finally
  PlayList.Items.EndUpdate;
  PlayList.Update;
 end;
end;

procedure TForm1.WMDropFiles(Var Msg:TMessage);
Const
 MaxLen=512;
var
 count:integer;
 s:string;
 i:integer;
 l:integer;
begin
 count:=DragQueryFile(Msg.wParam,uint(-1),nil,0);
 for i:=0 to count-1 do begin
  SetLength(s,MaxLen);
  l:=DragQueryFile(Msg.wParam,i,pchar(s),length(s));
  Setlength(s,l);
  if UpperCase(ExtractFileExt(s))='.MP3' then begin
   PlayList.Items.AddObject(s,TDSPlayer.Create(s));
  end;
 end;
 DragFinish(Msg.wParam);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
 i:integer;
 p:TDSPlayer;
begin
 Application.OnIdle:=nil;
 for i:=PlayList.Count-1 downto 0 do begin
  p:=PlayList.Items.Objects[i] as TDSPlayer;
  p.Free;
 end;
end;

end.
